
/*################################################################################################
 *##################                                                            ##################
 *##################                                                            ##################
 *##################                   Built-in Functions                       ##################
 *##################                     Implementation                         ##################
 *##################                                                            ##################
 *################################################################################################
 */

/*
 * XCLstd: standard built-ins implementation for the XCLE library
 *
 * Copyright (C) 2000 Yann LANDRIN-SCHWEITZER
 *
 *
 * This library is free software;  you can redistribute it and/or modify it
 * under  the terms of the  GNU Lesser General Public License  as published
 * by the  Free Software Foundation;  either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This  library  is  distributed  in  the hope that it will be useful, but
 * WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library;  if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *
 * Author:   Yann LANDRIN-SCHWEITZER
 * Contact:  varkhan@free.fr
 * Homepage: http://varkhan.free.fr/
 */


#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>

#include <math.h>
#include <string.h>

#include <DbgLog.h>

#include <XCLE/Containers.h>

#include <XCLE/Obj_generic.h>
#include <XCLE/Obj_void.h>
#include <XCLE/Obj_intg.h>
#include <XCLE/Obj_fltp.h>
#include <XCLE/Obj_strg.h>
#include <XCLE/Obj_list.h>
#include <XCLE/Obj_code.h>

#include <XCLE/Mod_string.h>
#include <XCLE/Mod_exec.h>
#include <XCLE/Mod_write.h>
#include <XCLE/Mod_parse.h>

#include "Primitives.h"

#define XCLE_Primitive(name)   static const XCLE_Exception name(XCLE_ExecCtx ctx, XCLE_Stack stk, XCLE_Hash hsh, XCLE_Object dat)
#define GETSTACK()      stk
#define GETNAMES()      hsh
#define SETSTATUS(e)    return e
#define SETSTATUSMSG(m) return XCLE_ExceptionNew(ERR_MAXSYSERR,m)
#define SETSTATUSNUM(e) return XCLE_ExceptionNew(ERR_##e,MSG_##e)
#define STATUSOK()      return XCLE_EXCEPTION_OK

#include "Primitives_header.c"
#include "Primitives_misccd.c"
#include "Primitives_functn.c"
#include "Primitives_struct.c"
