// ## Static XCLE_Bltn Definition
// DEFINE loop
// INTERN loop


XCLE_Primitive(_CodeCall_loop) ;


static const XCLE_CodeDef _CodeData_loop = 
	{
		"loop",
		1, { 8    },
		~0, { ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0},
		(const XCLE_CodeOperator) _CodeCall_loop,
		"Loops execution of a portion of code until false is returned"
	} ;


XCLE_Primitive(_CodeCall_loop) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned short t ;
       	XCLE_Exception ret ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		t = 1 ;
		while(t) {
			ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj1) ;
			if(ret!=XCLE_EXCEPTION_OK) {
				XCLE_ObjectFree(obj1) ;
				SETSTATUS(ret) ;
				/* return ; */
			}
			if(XCLE_StackDepth(GETSTACK())<1) {
				SETSTATUSNUM(TOOFEWARG) ;
				/* return ; */
			}
			t = 1 ;
			if(XCLE_StackChkType(GETSTACK(),1,&t)) {
				SETSTATUSNUM(INVARGTYP) ;
				/* return ; */
			}
			obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
			if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
			switch(XCLE_ObjectType(obj2)) {
				case XCLE_OT_INTG:
					t = (XCLE_IntgValue((XCLE_Intg)obj2)!=0) ;
					XCLE_ObjectFree(obj2) ;
					break ;
#ifdef DOCHECK
				default:
					XCLE_ObjectFree(obj2) ;
					SETSTATUSNUM(RUNTIME) ;
					/* return ; */
#endif
			}
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}


