// ## Static XCLE_Bltn Definition
// DEFINE lstcat
// INTERN lstcat


XCLE_Primitive(_CodeCall_lstcat) ;


static const XCLE_CodeDef _CodeData_lstcat = 
	{	"lstcat",
		2, { 8, 8 },
		1, { 8    },
		(const XCLE_CodeOperator) _CodeCall_lstcat,
		"Concatenes two lists"
	} ;


XCLE_Primitive(_CodeCall_lstcat) {
	XCLE_List lst1, lst2 ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			lst1 = XCLE_ListClone((XCLE_List)obj2) ;
			lst2 = XCLE_ListClone((XCLE_List)obj1) ;
			obj = XCLE_AnyToObject(XCLE_ListIns(lst1,XCLE_ListLen(lst1),lst2)) ;
			XCLE_ListFree(lst2) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}


