// ## Static XCLE_Bltn Definition
// DEFINE lstpop
// INTERN lstpop


XCLE_Primitive(_CodeCall_lstpop) ;


static const XCLE_CodeDef _CodeData_lstpop = 
	{	"lstpop",
		1, { 8    },
		2, { ~0, 8 },
		(const XCLE_CodeOperator) _CodeCall_lstpop,
		"Pops the last element of a list"
	} ;


XCLE_Primitive(_CodeCall_lstpop) {
	XCLE_List lst ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj)) {
	case XCLE_OT_LIST:
		if(XCLE_ListLen((XCLE_List)obj)==0) {
			XCLE_ObjectFree(obj) ;
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
		lst = XCLE_ListClone((XCLE_List)obj) ;
		obj1 = XCLE_ListPop(lst) ;
		if(obj1==NULL) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		obj2 = XCLE_AnyToObject(lst) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if((obj1==NULL)||(obj2==NULL)) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj2)==-1) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj1)==-1) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj) ;
	STATUSOK() ;
	/* return ; */
}


