// ## Static XCLE_Bltn Definition
// DEFINE *
// INTERN nummul


XCLE_Primitive(_CodeCall_nummul) ;


static const XCLE_CodeDef _CodeData_nummul = 
	{	"*",
		2, { 3, 3 },
		1, { 3    },
		(const XCLE_CodeOperator) _CodeCall_nummul,
		"Numeric product"
	} ;


XCLE_Primitive(_CodeCall_nummul) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) * XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_IntgValue((XCLE_Intg)obj1) * XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) * XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) * XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


