// ## Static XCLE_Bltn Definition
// DEFINE strcat
// INTERN strcat


XCLE_Primitive(_CodeCall_strcat) ;


static const XCLE_CodeDef _CodeData_strcat = 
	{	"strcat",
		2, { 4, 4 },
		1, { 4    },
		(const XCLE_CodeOperator) _CodeCall_strcat,
		"Concatenes two strings"
	} ;


XCLE_Primitive(_CodeCall_strcat) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_STRG:
			obj = XCLE_AnyToObject(XCLE_StrgCat((XCLE_Strg)obj2,(XCLE_Strg)obj1)) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}


