
//DEFINE numpow

XCLE_Primitive(_CodeCall_numpow) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew((long)pow((double)XCLE_IntgValue((XCLE_Intg)obj2),(double)XCLE_IntgValue((XCLE_Intg)obj1)))) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew((double)pow((double)XCLE_FltpValue((XCLE_Fltp)obj2),(double)XCLE_IntgValue((XCLE_Intg)obj1)))) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_FltpNew((double)pow((double)XCLE_IntgValue((XCLE_Intg)obj2),(double)XCLE_FltpValue((XCLE_Fltp)obj1)))) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew((double)pow((double)XCLE_FltpValue((XCLE_Fltp)obj2),(double)XCLE_FltpValue((XCLE_Fltp)obj1)))) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE IsStrg

XCLE_Primitive(_CodeCall_IsStrg) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if( (obj1==NULL) ) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj = XCLE_AnyToObject(XCLE_IntgNew(XCLE_ObjectType(obj1)==XCLE_OT_STRG)) ;
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE IsFltp

XCLE_Primitive(_CodeCall_IsFltp) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_FLTP:
		obj = XCLE_AnyToObject(XCLE_IntgNew(1)) ;
		break ;
	default:
		obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE print

XCLE_Primitive(_CodeCall_print) {
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	XCLE_ObjectPrint(obj1,1) ;
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE if

XCLE_Primitive(_CodeCall_if) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
       	XCLE_Exception ret ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			if(XCLE_IntgValue((XCLE_Intg)obj1)) {
				ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj2) ;
				if(ret!=XCLE_EXCEPTION_OK) {
					XCLE_ObjectFree(obj1) ;
					XCLE_ObjectFree(obj2) ;
					SETSTATUS(ret) ;
					/* return ; */
				}
			}
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE loop

XCLE_Primitive(_CodeCall_loop) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned short t ;
       	XCLE_Exception ret ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		t = 1 ;
		while(t) {
			ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj1) ;
			if(ret!=XCLE_EXCEPTION_OK) {
				XCLE_ObjectFree(obj1) ;
				SETSTATUS(ret) ;
				/* return ; */
			}
			if(XCLE_StackDepth(GETSTACK())<1) {
				SETSTATUSNUM(TOOFEWARG) ;
				/* return ; */
			}
			t = 1 ;
			if(XCLE_StackChkType(GETSTACK(),1,&t)) {
				SETSTATUSNUM(INVARGTYP) ;
				/* return ; */
			}
			obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
			if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
			switch(XCLE_ObjectType(obj2)) {
				case XCLE_OT_INTG:
					t = (XCLE_IntgValue((XCLE_Intg)obj2)!=0) ;
					XCLE_ObjectFree(obj2) ;
					break ;
#ifdef DOCHECK
				default:
					XCLE_ObjectFree(obj2) ;
					SETSTATUSNUM(RUNTIME) ;
					/* return ; */
#endif
			}
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE println

XCLE_Primitive(_CodeCall_println) {
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	XCLE_ObjectPrint(obj1,1) ;
	XCLE_ObjectFree(obj1) ;
	if(write(1,"\n",1)<1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numgt

XCLE_Primitive(_CodeCall_numgt) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj2) > XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) > (double)XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (double)XCLE_IntgValue((XCLE_Intg)obj2) > XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) > XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE dropN

XCLE_Primitive(_CodeCall_dropN) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned long i = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		i = (long)XCLE_IntgValue((XCLE_Intg)obj1) ;
		break ;
	case XCLE_OT_FLTP:
		i = (long)XCLE_FltpValue((XCLE_Fltp)obj1) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if((i>=0)&&(i<=XCLE_StackDepth(GETSTACK()))) {
		while(i>0) {
			obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
			if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
			XCLE_ObjectFree(obj2) ;
			i -- ;
		}
	}
	else {
		SETSTATUSNUM(INVARGVAL) ;
		/* return ; */
	}
	STATUSOK() ;
	/* return ; */
}




//DEFINE dupN

XCLE_Primitive(_CodeCall_dupN) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned long i = 0 ;
	unsigned long j ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		i = (long)XCLE_IntgValue((XCLE_Intg)obj1) ;
		break ;
	case XCLE_OT_FLTP:
		i = (long)XCLE_FltpValue((XCLE_Fltp)obj1) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if((i>=0)&&(i<=XCLE_StackDepth(GETSTACK()))) {
		j = i ;
		while(j>0) {
			obj2 = XCLE_StackGet(GETSTACK(),i) ;
#ifdef DOCHECK
			if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
			XCLE_StackPush(GETSTACK(),obj2) ;
			j -- ;
		}
	}
	else {
		SETSTATUSNUM(INVARGVAL) ;
		/* return ; */
	}
	STATUSOK() ;
	/* return ; */
}




//DEFINE numne

XCLE_Primitive(_CodeCall_numne) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) != XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) != XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj1) != XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj1) != XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE bitxor

XCLE_Primitive(_CodeCall_bitxor) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) ^ XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE varset

XCLE_Primitive(_CodeCall_varset) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	char str[MAX_VAR_LEN+1] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,MAX_VAR_LEN) ;
		obj2 = XCLE_HashSet(GETNAMES(),str,obj2) ;
#ifdef DOCHECK
		if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstpush

XCLE_Primitive(_CodeCall_lstpush) {
	XCLE_List lst ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj2)) {
	case XCLE_OT_LIST:
		lst = (XCLE_List)XCLE_ObjectClone(obj2) ;
		XCLE_ListPush(lst,obj1) ;
		obj = XCLE_AnyToObject(lst) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE swap

XCLE_Primitive(_CodeCall_swap) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	if(XCLE_StackPush(GETSTACK(),obj1)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj2)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE bitor

XCLE_Primitive(_CodeCall_bitor) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) | XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE undef

XCLE_Primitive(_CodeCall_undef) {
	XCLE_Object obj = NULL ;
	obj = XCLE_AnyToObject(XCLE_VoidAlloc()) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstcat

XCLE_Primitive(_CodeCall_lstcat) {
	XCLE_List lst1, lst2 ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			lst1 = XCLE_ListClone((XCLE_List)obj2) ;
			lst2 = XCLE_ListClone((XCLE_List)obj1) ;
			obj = XCLE_AnyToObject(XCLE_ListIns(lst1,XCLE_ListLen(lst1),lst2)) ;
			XCLE_ListFree(lst2) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE numlt

XCLE_Primitive(_CodeCall_numlt) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj2) < XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) < (double)XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (double)XCLE_IntgValue((XCLE_Intg)obj2) < XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) < XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE stkpeek

XCLE_Primitive(_CodeCall_stkpeek) {
	unsigned long n = 0 ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		n = XCLE_IntgValue((XCLE_Intg)obj1) ;
		if((n==0)||(n>XCLE_StackDepth(GETSTACK()))) {
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
//		obj = XCLE_ObjectCopy(XCLE_StackGet(GETSTACK(),XCLE_IntgValue((XCLE_Intg)obj1))) ;
		obj = XCLE_StackGet(GETSTACK(),n) ;
#ifdef DOCHECK
		if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE tostr

XCLE_Primitive(_CodeCall_tostr) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	char * buffer ;
	unsigned long len ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	len = XCLE_ObjectToString(obj1,NULL,0) ;
	if(len==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	buffer = malloc(len+1) ;
	if(XCLE_ObjectToString(obj1,buffer,len+1)!=len) { free(buffer) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	buffer[len] = '\0' ;
	obj = XCLE_AnyToObject(XCLE_StrgNew(buffer)) ;
	free(buffer) ;
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstmap

XCLE_Primitive(_CodeCall_lstmap) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
       	XCLE_Exception ret ;
	unsigned long l, i ;
	XCLE_List lst ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			lst = XCLE_ListAlloc() ;
			l = XCLE_ListLen((XCLE_List)obj2) ;
			i = 0 ;
			while(i<l) {
				XCLE_StackPush(GETSTACK(),XCLE_ListGet((XCLE_List)obj2,i)) ;
				ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj1) ;
				if(ret!=XCLE_EXCEPTION_OK) {
					XCLE_ObjectFree(obj1) ;
					SETSTATUS(ret) ;
					/* return ; */
				}
				if(XCLE_StackDepth(GETSTACK())>0) XCLE_ListPush(lst,XCLE_StackPop(GETSTACK())) ;
				i ++ ;
			}
			obj = XCLE_AnyToObject(lst) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if(obj==NULL) {
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
	}
	if(XCLE_StackPush(GETSTACK(),obj)==-1) {
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE numinc

XCLE_Primitive(_CodeCall_numinc) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) + 1 )) ;
		break ;
	case XCLE_OT_FLTP:
		obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) + 1 )) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE stkprint

XCLE_Primitive(_CodeCall_stkprint) {
#ifdef DUMP_STAT
	unsigned long i = 0 ;
#endif
#ifdef DUMP_STAT
	i = XCLE_StackDepth(GETSTACK()) ;
	while(i>0) {
		XCLE_ObjectStat(XCLE_StackGet(GETSTACK(),i)) ;
		i -- ;
	}
#endif
	XCLE_StackPrintF(GETSTACK(),1,STK_HDR,STK_FMT,STK_TLR,8) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstsize

XCLE_Primitive(_CodeCall_lstsize) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_List lst = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		lst = (XCLE_List)obj1 ;
		obj = XCLE_AnyToObject(XCLE_IntgNew(XCLE_ListLen(lst))) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE strlen

XCLE_Primitive(_CodeCall_strlen) {
	XCLE_Object obj1 = NULL ;
	unsigned long s = 0 ;
	XCLE_Object obj = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		s = XCLE_StrgLen((XCLE_Strg)obj1) ;
		if(s==-1) { XCLE_ObjectFree(obj1) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		obj = XCLE_AnyToObject(XCLE_IntgNew(s)) ;
		if(obj==NULL) { XCLE_ObjectFree(obj1) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE drop

XCLE_Primitive(_CodeCall_drop) {
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE true

XCLE_Primitive(_CodeCall_true) {
	XCLE_Object obj = NULL ;
	obj = XCLE_AnyToObject(XCLE_IntgNew(1)) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE die

XCLE_Primitive(_CodeCall_die) {
	SETSTATUSMSG("Died") ;
	/* return ; */
}




//DEFINE error

XCLE_Primitive(_CodeCall_error) {
	XCLE_Exception stat ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned long num = ERR_RUNTIME ;
	static char msg[256] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_STRG:
			num = (long)XCLE_IntgValue((XCLE_Intg)obj1) ;
			XCLE_StrgValue((XCLE_Strg)obj2,msg,255) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	stat = XCLE_ExceptionNew(num,msg) ;
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	printf("Died! < %lu - %s >\n",num,msg) ;
	SETSTATUS(stat) ;
	/* return ; */
}




//DEFINE bitnot

XCLE_Primitive(_CodeCall_bitnot) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_AnyToObject(XCLE_IntgNew(~XCLE_IntgValue((XCLE_Intg)obj1))) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE IsList

XCLE_Primitive(_CodeCall_IsList) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if( (obj1==NULL) ) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj = XCLE_AnyToObject(XCLE_IntgNew(XCLE_ObjectType(obj1)==XCLE_OT_LIST)) ;
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE toobj

XCLE_Primitive(_CodeCall_toobj) {
	extern XCLE_ParseCtx XCL_parse_ctx ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_List lst ;
	char * str = NULL ;
	unsigned long off = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		str = malloc(XCLE_StrgLen((XCLE_Strg)obj1)+1) ;
		if(str==NULL) {
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
			break ;
		}
		str[0] = 0 ;	// Just to be sure
		XCLE_StrgValue((XCLE_Strg)obj1,str,XCLE_StrgLen((XCLE_Strg)obj1)) ;
		lst = XCLE_ListParse(XCL_parse_ctx,str,&off) ;
		free(str) ;
		if(lst==NULL) {
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(PARSEERR) ;
			/* return ; */
		}
		obj = XCLE_AnyToObject(lst) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numeq

XCLE_Primitive(_CodeCall_numeq) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) == XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (double)XCLE_IntgValue((XCLE_Intg)obj1) == XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj1) == (double)XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj1) == XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE vardef

XCLE_Primitive(_CodeCall_vardef) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	char str[MAX_VAR_LEN+1] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,MAX_VAR_LEN) ;
		obj = XCLE_HashGet(GETNAMES(),str) ;
		if(obj==NULL) obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
		else obj = XCLE_AnyToObject(XCLE_IntgNew(1)) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE strcat

XCLE_Primitive(_CodeCall_strcat) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_STRG:
			obj = XCLE_AnyToObject(XCLE_StrgCat((XCLE_Strg)obj2,(XCLE_Strg)obj1)) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE numdec

XCLE_Primitive(_CodeCall_numdec) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) - 1 )) ;
		break ;
	case XCLE_OT_FLTP:
		obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) - 1 )) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE blnor

XCLE_Primitive(_CodeCall_blnor) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) || XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE dup

XCLE_Primitive(_CodeCall_dup) {
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackGet(GETSTACK(),1) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	if(XCLE_StackPush(GETSTACK(),XCLE_ObjectCopy(obj1))==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numrnd

XCLE_Primitive(_CodeCall_numrnd) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_AnyToObject(XCLE_IntgNew( (long)XCLE_IntgValue((XCLE_Intg)obj1) )) ;
		break ;
	case XCLE_OT_FLTP:
		obj = XCLE_AnyToObject(XCLE_IntgNew( (long)XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numdiv

XCLE_Primitive(_CodeCall_numdiv) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		if(XCLE_IntgValue((XCLE_Intg)obj1)==0) {
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj2) / XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj2) / XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		if(XCLE_FltpValue((XCLE_Fltp)obj1)==0) {
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_IntgValue((XCLE_Intg)obj2) / XCLE_FltpValue((XCLE_Fltp)obj1)  )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj2) / XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE bitand

XCLE_Primitive(_CodeCall_bitand) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) & XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE false

XCLE_Primitive(_CodeCall_false) {
	XCLE_Object obj = NULL ;
	obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE stkclear

XCLE_Primitive(_CodeCall_stkclear) {
	XCLE_Object obj ;
	while(XCLE_StackDepth(GETSTACK())) {
		obj = XCLE_StackPop(GETSTACK()) ;
		XCLE_ObjectFree(obj) ;
	}
	STATUSOK() ;
	/* return ; */
}




//DEFINE varlst

XCLE_Primitive(_CodeCall_varlst) {
	XCLE_Object obj = NULL ;
	obj = XCLE_AnyToObject(XCLE_ListAlloc()) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_HashMap(GETNAMES(),_CodeCall_varlst_map,(void *)obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numsub

XCLE_Primitive(_CodeCall_numsub) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj2) - XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj2) - XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_IntgValue((XCLE_Intg)obj2) - XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj2) - XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstbrk

XCLE_Primitive(_CodeCall_lstbrk) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	unsigned long l = 0 ;
	unsigned long i = 0 ;
	XCLE_List lst ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		lst = (XCLE_List)obj1 ;
		l = XCLE_ListLen(lst) ;
		while(i<l) {
			obj = XCLE_ListGet(lst,i) ;
			if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
			if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
			i ++ ;
		}
		obj = XCLE_AnyToObject(XCLE_IntgNew(l)) ;
		if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE lsttrn

XCLE_Primitive(_CodeCall_lsttrn) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	XCLE_Object obj3 = NULL ;
       	XCLE_Exception ret ;
	unsigned short t ;
	unsigned long l, i ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			XCLE_ListUpRef((XCLE_List)obj2) ;
			l = XCLE_ListLen((XCLE_List)obj2) ;
			i = 0 ;
			t = 1 ;
			while((i<l)&&t) {
				XCLE_StackPush(GETSTACK(),XCLE_ListGet((XCLE_List)obj2,i)) ;
				ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj1) ;
				if(ret!=XCLE_EXCEPTION_OK) {
					XCLE_ListDnRef((XCLE_List)obj2) ;
					XCLE_ObjectFree(obj1) ;
					SETSTATUS(ret) ;
					/* return ; */
				}
				/*
				if(XCLE_StackChkType(GETSTACK(),1,&t)) {
					STATUSOK() ;
					// return ; 
				}
				*/
				obj3 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
				if(obj3==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
				switch(XCLE_ObjectType(obj3)) {
					case XCLE_OT_INTG:
						t = (XCLE_IntgValue((XCLE_Intg)obj3)!=0) ;
						XCLE_ObjectFree(obj3) ;
						break ;
#ifdef DOCHECK
					default:
						XCLE_ListDnRef((XCLE_List)obj2) ;
						XCLE_ObjectFree(obj3) ;
						SETSTATUSNUM(RUNTIME) ;
						/* return ; */
#endif
				}
				i ++ ;
			}
			XCLE_ListDnRef((XCLE_List)obj2) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE exec

XCLE_Primitive(_CodeCall_exec) {
	XCLE_Object obj1 = NULL ;
       	XCLE_Exception ret ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj1) ;
		if(ret!=XCLE_EXCEPTION_OK) {
			XCLE_ObjectFree(obj1) ;
			SETSTATUS(ret) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstgrp

XCLE_Primitive(_CodeCall_lstgrp) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned long i = 0 ;
	XCLE_List lst = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		lst = XCLE_ListAlloc() ;
		i = XCLE_IntgValue((XCLE_Intg)obj1) ;
		if(i<0) {
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
		if(i>XCLE_StackDepth(GETSTACK())) {
			SETSTATUSNUM(TOOFEWARG) ;
			/* return ; */
		}
		while(i>0) {
			obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
			if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
			if(XCLE_ListUnshift(lst,obj2)==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
			i -- ;
		}
		obj = XCLE_AnyToObject(lst) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numlte

XCLE_Primitive(_CodeCall_numlte) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj2) <= XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) <= (double)XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (double)XCLE_IntgValue((XCLE_Intg)obj2) <= XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) <= XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numquo

XCLE_Primitive(_CodeCall_numquo) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		if(XCLE_IntgValue((XCLE_Intg)obj1)==0) {
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (long) XCLE_IntgValue((XCLE_Intg)obj2) / XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (long) XCLE_FltpValue((XCLE_Fltp)obj2) / XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		if(XCLE_FltpValue((XCLE_Fltp)obj2)==0) {
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (long) XCLE_IntgValue((XCLE_Intg)obj2) / XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (long) XCLE_FltpValue((XCLE_Fltp)obj2) / XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE varget

XCLE_Primitive(_CodeCall_varget) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	char str[MAX_VAR_LEN+1] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,MAX_VAR_LEN) ;
		obj = XCLE_HashGet(GETNAMES(),str) ;
		if(obj==NULL) {
			SETSTATUSNUM(NOSUCHVR) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE depth

XCLE_Primitive(_CodeCall_depth) {
	XCLE_Object obj = NULL ;
	obj = XCLE_AnyToObject(XCLE_IntgNew(XCLE_StackDepth(GETSTACK()))) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE noop

XCLE_Primitive(_CodeCall_noop) {
	STATUSOK() ;
	/* return ; */
}




//DEFINE nummul

XCLE_Primitive(_CodeCall_nummul) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) * XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_IntgValue((XCLE_Intg)obj1) * XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) * XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) * XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE IsDef

XCLE_Primitive(_CodeCall_IsDef) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_VOID:
		obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
		break ;
	default:
		obj = XCLE_AnyToObject(XCLE_IntgNew(1)) ;
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE stkpoke

XCLE_Primitive(_CodeCall_stkpoke) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	unsigned long n ;
	unsigned long i ;
	XCLE_Object * tab ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
		if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	n = XCLE_IntgValue((XCLE_Intg)obj1) ;
	if(n<2) {
		XCLE_ObjectFree(obj1) ;
		STATUSOK() ;
		/* return ; */
	}
	n -- ;
	tab = malloc(n*sizeof(XCLE_Object)) ;
	if(tab==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	i = n ;
	while(i>0) {
		i -- ;
		tab[i] = XCLE_StackPop(GETSTACK()) ;
	}
	XCLE_StackPush(GETSTACK(),obj) ;
	while(i<n) {
		XCLE_StackPush(GETSTACK(),tab[i]) ;
		i ++ ;
	}
	free(tab) ;
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE stkroll

XCLE_Primitive(_CodeCall_stkroll) {
	unsigned long i ;
	XCLE_Object obj = NULL ;
	if(XCLE_StackDepth(GETSTACK())>0) {
		obj = XCLE_StackGet(GETSTACK(),1) ;
		i = XCLE_StackDepth(GETSTACK()) ;
		while(i>0) {
			obj = XCLE_StackPut(GETSTACK(),obj,i) ;
			i -- ;
		}
	}
	STATUSOK() ;
	/* return ; */
}




//DEFINE stkrot

XCLE_Primitive(_CodeCall_stkrot) {
	unsigned long i ;
	XCLE_Object obj = NULL ;
	if(XCLE_StackDepth(GETSTACK())>0) {
		obj = XCLE_StackGet(GETSTACK(),XCLE_StackDepth(GETSTACK())) ;
		i = 1 ;
		while(i<=XCLE_StackDepth(GETSTACK())) {
			obj = XCLE_StackPut(GETSTACK(),obj,i) ;
			i ++ ;
		}
	}
	STATUSOK() ;
	/* return ; */
}




//DEFINE ifelse

XCLE_Primitive(_CodeCall_ifelse) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	XCLE_Object obj3 = NULL ;
       	XCLE_Exception ret ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj3 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj3==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			switch(XCLE_ObjectType(obj3)) {
			case XCLE_OT_LIST:
				if(XCLE_IntgValue((XCLE_Intg)obj1)) {
					ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj2) ;
					if(ret!=XCLE_EXCEPTION_OK) {
						XCLE_ObjectFree(obj1) ;
						XCLE_ObjectFree(obj2) ;
						XCLE_ObjectFree(obj3) ;
						SETSTATUS(ret) ;
						/* return ; */
					}
				}
				else {
					ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj3) ;
					if(ret!=XCLE_EXCEPTION_OK) {
						XCLE_ObjectFree(obj1) ;
						XCLE_ObjectFree(obj2) ;
						XCLE_ObjectFree(obj3) ;
						SETSTATUS(ret) ;
						/* return ; */
					}
				}
				break ;
#ifdef DOCHECK
			default:
				XCLE_ObjectFree(obj1) ;
				XCLE_ObjectFree(obj2) ;
				XCLE_ObjectFree(obj3) ;
				SETSTATUSNUM(RUNTIME) ;
				/* return ; */
#endif
			}
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			XCLE_ObjectFree(obj3) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		XCLE_ObjectFree(obj3) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	XCLE_ObjectFree(obj3) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE varexe

XCLE_Primitive(_CodeCall_varexe) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
       	XCLE_Exception ret ;
	char str[MAX_VAR_LEN+1] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,MAX_VAR_LEN) ;
		obj2 = XCLE_HashGet(GETNAMES(),str) ;
		if(obj2==NULL) {
			SETSTATUSNUM(NOSUCHVR) ;
			/* return ; */
		}
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj2) ;
			if(ret!=XCLE_EXCEPTION_OK) {
				XCLE_ObjectFree(obj1) ;
				SETSTATUS(ret) ;
				/* return ; */
			}
			break ;
		default:
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(INVARGTYP) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE vardel

XCLE_Primitive(_CodeCall_vardel) {
	XCLE_Object obj1 = NULL ;
	char str[MAX_VAR_LEN] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,MAX_VAR_LEN) ;
		obj1 = XCLE_HashDel(GETNAMES(),str) ;
		if(obj1==NULL) {
			SETSTATUSNUM(NOSUCHVR) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE help

XCLE_Primitive(_CodeCall_help) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	char str[CDEF_NAME_LEN+1] ;
	extern XCLE_ParseCtx XCL_parse_ctx ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,CDEF_NAME_LEN) ;
		obj = XCLE_AnyToObject(XCLE_StrgNew(XCLE_ParseCtx_DescByName(XCL_parse_ctx,str))) ;
		if(obj==NULL) {
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(PARSEERR) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE IsIntg

XCLE_Primitive(_CodeCall_IsIntg) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_AnyToObject(XCLE_IntgNew(1)) ;
		break ;
	default:
		obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE equal

XCLE_Primitive(_CodeCall_equal) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned long t = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	if(XCLE_ObjectType(obj1)!=XCLE_ObjectType(obj2)) obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
	else {
		t = XCLE_ObjectEqual(obj1,obj2) ;
#ifdef DOCHECK
		if(t==-1) {
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
		}
#endif
		obj = XCLE_AnyToObject(XCLE_IntgNew(t)) ;
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstget

XCLE_Primitive(_CodeCall_lstget) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	XCLE_List lst ;
	unsigned long i = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			i = (long)XCLE_IntgValue((XCLE_Intg)obj1) ;
			lst = (XCLE_List)obj2 ;
			if(i<0) {
				XCLE_ObjectFree(obj1) ;
				XCLE_ObjectFree(obj2) ;
				SETSTATUSNUM(INVARGVAL) ;
				/* return ; */
			}
			else if(i<XCLE_ListLen(lst)) {
				obj = XCLE_ListGet(lst,i) ;
			}
			else {
				XCLE_ObjectFree(obj1) ;
				XCLE_ObjectFree(obj2) ;
				SETSTATUSNUM(OUTRANGE) ;
				/* return ; */
			}
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { XCLE_ObjectFree(obj1) ; XCLE_ObjectFree(obj2) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE lstpop

XCLE_Primitive(_CodeCall_lstpop) {
	XCLE_List lst ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj)) {
	case XCLE_OT_LIST:
		if(XCLE_ListLen((XCLE_List)obj)==0) {
			XCLE_ObjectFree(obj) ;
			SETSTATUSNUM(INVARGVAL) ;
			/* return ; */
		}
		lst = XCLE_ListClone((XCLE_List)obj) ;
		obj1 = XCLE_ListPop(lst) ;
		if(obj1==NULL) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		obj2 = XCLE_AnyToObject(lst) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	if((obj1==NULL)||(obj2==NULL)) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj2)==-1) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj1)==-1) { XCLE_ObjectFree(obj) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	XCLE_ObjectFree(obj) ;
	STATUSOK() ;
	/* return ; */
}




//DEFINE nummod

XCLE_Primitive(_CodeCall_nummod) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj2)%XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE blnnot

XCLE_Primitive(_CodeCall_blnnot) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_AnyToObject(XCLE_IntgNew(!XCLE_IntgValue((XCLE_Intg)obj1))) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE blnand

XCLE_Primitive(_CodeCall_blnand) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) && XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numgte

XCLE_Primitive(_CodeCall_numgte) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj2) >= XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) >= (double)XCLE_IntgValue((XCLE_Intg)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( (double)XCLE_IntgValue((XCLE_Intg)obj2) >= XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_FltpValue((XCLE_Fltp)obj2) >= XCLE_FltpValue((XCLE_Fltp)obj1) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE numadd

XCLE_Primitive(_CodeCall_numadd) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew( XCLE_IntgValue((XCLE_Intg)obj1) + XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_IntgValue((XCLE_Intg)obj1) + XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) + XCLE_IntgValue((XCLE_Intg)obj2) )) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew( XCLE_FltpValue((XCLE_Fltp)obj1) + XCLE_FltpValue((XCLE_Fltp)obj2) )) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}




//DEFINE strprint

XCLE_Primitive(_CodeCall_strprint) {
	XCLE_Object obj1 = NULL ;
	char * str = NULL ;
	unsigned long s = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		str = malloc(XCLE_StrgLen((XCLE_Strg)obj1)+1) ;
		if(str==NULL) {
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
			break ;
		}
		str[0] = 0 ;	// Just to be sure
		s = XCLE_StrgValue((XCLE_Strg)obj1,str,XCLE_StrgLen((XCLE_Strg)obj1)) ;
		str[s] = '\0' ;
		if(write(1,str,s)<s) {
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}



